------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Layout_Items.Impl;
with Qt4.Layouts;
with Qt4.Sizes;
with Qt4.Widgets;
with Qt_Ada.Internals.Objects.Object_Proxies;

package Qt_Ada.Internals.Objects.Layout_Proxies is

   pragma Elaborate_Body;

   type Q_Layout_Proxy is
     new Qt_Ada.Internals.Objects.Object_Proxies.Q_Object_Proxy
       and Qt4.Layouts.Q_Layout with null record;

   procedure Add_Item
    (Self : not null access Q_Layout_Proxy;
     Item : not null access Qt4.Layout_Items.Q_Layout_Item'Class);

   function Count
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Q_Integer;

   function Index_Of
    (Self : not null access constant Q_Layout_Proxy;
     Widget : not null access Qt4.Widgets.Q_Widget'Class)
       return Qt4.Q_Integer;

   function Is_Empty
    (Self : not null access constant Q_Layout_Proxy)
       return Standard.Boolean;

   function Minimum_Size
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Sizes.Q_Size;

   function Maximum_Size
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Sizes.Q_Size;

   function Has_Height_For_Width
    (Self : not null access constant Q_Layout_Proxy)
       return Standard.Boolean;

   function Height_For_Width
    (Self : not null access constant Q_Layout_Proxy;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   procedure Invalidate
    (Self : not null access Q_Layout_Proxy);

   function Layout
    (Self : not null access Q_Layout_Proxy)
       return not null access Qt4.Layouts.Q_Layout'Class;

   function Minimum_Height_For_Width
    (Self : not null access constant Q_Layout_Proxy;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Size_Hint
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Sizes.Q_Size;

   function Widget
    (Self : not null access Q_Layout_Proxy)
       return not null access Qt4.Widgets.Q_Widget'Class;

   overriding
   function Expanding_Directions
    (Self : not null access constant Q_Layout_Proxy)
       return Qt4.Orientations;

--   overriding
   function QLayoutItem_View
    (Self : not null access constant Q_Layout_Proxy)
       return not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem;

end Qt_Ada.Internals.Objects.Layout_Proxies;
